class Flock {
  ArrayList agents; // An arraylist for all the boids

  Flock() {
    agents = new ArrayList(); // Initialize the arraylist
  }
  
  void run() {
    for (int i = 0; i < agents.size(); i++) {
      Agent b = (Agent) agents.get(i);  
      b.run(agents);  // Passing the entire list of boids to each boid individually
    }
  }

  void addAgent(Agent b) {
    agents.add(b);
  }

}


class Matrix 
{
  ArrayList<DeweyAttractor> deweyAttractor = new ArrayList<DeweyAttractor>();
      
  void setupDeweyAttractor() 
  {
    int x;
    int y;
    int z;
    
    for (DeweySelection d : deweySelection)
    {
      if (d.id < 10)
      {
        x = 0;
        y = 0; 
        z = d.id;
      }
      else if(d.id >= 10 & d.id < 100)
      {
        String number = Integer.toString(d.id); 
        x = 0; 
        y = Integer.parseInt(number.substring(0,1)); 
        z = Integer.parseInt(number.substring(1,2));
      }
      else
      {
        String number = Integer.toString(d.id); 
        x = Integer.parseInt(number.substring(0,1)); 
        y = Integer.parseInt(number.substring(1,2)); 
        z = Integer.parseInt(number.substring(2,3));
      }
      
      Vector3D poc = new Vector3D(x*gridSize+gridSize,y*gridSize+gridSize,z*gridSize+gridSize);   
      DeweyDict dd = deweyDict.get(d.id);
      deweyAttractor.add(new DeweyAttractor(poc, deweyCol, dd));
    }
  }
  
  void render() 
  {
     for (int i = 0; i < deweyAttractor.size(); i++) 
     {
      DeweyAttractor p = (DeweyAttractor) deweyAttractor.get(i);  
      p.render();

      

    }   
  }
}
